#ifndef _FYLE_TYPE_INCLUDE_
#define _FYLE_TYPE_INCLUDE_

///////////////////////
// Struktura souboru :
//
// st_GFile_Header
// st_GFile_Header.road    * st_GFile_Road
// st_GFile_Header.objects * st_GFile_Object
// EOF
//
///////////////////////
#define FILE_SIGN             2156 // nahodne, avsak nemene cislo
#define MAX_OBJECTS_ON_MAP   10000 // maximapli pocet objektu v mape
#define MAX_ROADS_ON_MAP      1000 // maximalni pocet zatacek silnice
#define MAX_ROADS_TYPES          5 // maximalni pocet zatacek silnice

typedef struct{
	long   sign;    // signatura - musi byt == FILE_SIGN
	BYTE   ver;     // urcuje verzi - musi byt == 1
	long   x;       // rozmer trate X (v pixelech)
	long   y;       // rozmer trate Y (v pixelech)
	long   road[MAX_ROADS_TYPES];    // pocet bodu silnice
	long   objects; // pocet objektu
	long   bonusu; // obrazek urcujici typ trate
	POINT  cam_start; // kde ma zacit kamera
	POINT  cam_end;   // kde ma kamera koncit
} st_GFile_Header;

typedef struct{
	long   sign;    // signatura - musi byt == FILE_SIGN
	BYTE   ver;     // urcuje verzi - musi byt == 1
	long   x;       // rozmer trate X (v pixelech)
	long   y;       // rozmer trate Y (v pixelech)
	long   road[MAX_ROADS_TYPES];    // pocet bodu silnice
	long   objects; // pocet objektu
	long   bonusu; // obrazek urcujici typ trate
	POINT  cam_start; // kde ma zacit kamera
	POINT  cam_end;   // kde ma kamera koncit
} st_GFile_Header2;


typedef struct{
	int      ID;       // index
	int      x;       // souradnice X (v pixelech)
	int      y;       // souradnice Y (v pixelech)
	// pozn. - typeB a typeA se nepouzivaji
	int   typeA;      // typ cesty A           \         pusobuje, ze se cesta muze
	int     IDA;      // index naslednika A      \ ___   pri smery sizdy <- vetvit 
	int   typeB;      // typ cesty B             /
	int     IDB;      // index naslednika B    /
} st_GFile_Road;


typedef struct{
	long     INDEX;    // cislo objektu v Oparams
	long        ID;    // cislo objekltu v sestavene databazi objektu
	long         x;    // souradnice X (v pixelech)
	long         y;    // souradnice Y (v pixelech)
	double   alpha;    // pocatecni natoceni ( ve stupnich )
	double turning;    // rychlost zataceni
	double   speed;    // rychlost pohybu
	double  angles;    // rychlost toceni ( 0 == nerotuje )
} st_GFile_Object;

typedef struct{
	int    circle_size;
	int    slower_distanc;
	int    slower_angle;
	double slower_speed;
	int    break_distanc;
	int    break_angle;
	double break_speed;
	int    speed_off_angle;
	double speed_off_speed;
	int    hbreak_angle;
	double hbreak_speed;
} st_GFile_Driving;

#endif //#ifndef _FYLE_TYPE_INCLUDE_
